VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Lecture fichier INI"
   ClientHeight    =   9810
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   9810
   ScaleWidth      =   8520
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton BTfermer 
      Caption         =   "Fermer"
      Height          =   495
      Left            =   6960
      TabIndex        =   8
      Top             =   9120
      Width           =   1455
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   6360
      TabIndex        =   7
      Top             =   4320
      Width           =   1935
   End
   Begin VB.CommandButton BTenregistrer 
      Caption         =   "Enregistrer"
      Height          =   495
      Left            =   4800
      TabIndex        =   6
      Top             =   5040
      Width           =   1455
   End
   Begin VB.CommandButton BTsupprimer 
      Caption         =   "Supprimer"
      Height          =   495
      Left            =   4800
      TabIndex        =   5
      Top             =   3360
      Width           =   1455
   End
   Begin VB.CommandButton BTajouter 
      Caption         =   "Ajouter"
      Height          =   495
      Left            =   4800
      TabIndex        =   4
      Top             =   4200
      Width           =   1455
   End
   Begin VB.ListBox List1 
      Height          =   2010
      Left            =   4800
      TabIndex        =   3
      Top             =   960
      Width           =   3495
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   4800
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   360
      Width           =   3495
   End
   Begin VB.PictureBox Text1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   9375
      Left            =   120
      ScaleHeight     =   9345
      ScaleWidth      =   4425
      TabIndex        =   0
      Top             =   360
      Width           =   4455
   End
   Begin VB.Label Label2 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Contenu du fichier."
      ForeColor       =   &H80000008&
      Height          =   300
      Left            =   120
      TabIndex        =   9
      Top             =   50
      Width           =   3495
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Gestion de la table des aliments."
      ForeColor       =   &H80000008&
      Height          =   375
      Left            =   4800
      TabIndex        =   1
      Top             =   50
      Width           =   3495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Ini As New Collection

Private Sub Form_Load()
  Dim i%, j%, k%
  Call GetIni(Ini, App.Path & "\" & App.Title & ".ini")
  Me.Show
  Text1.Cls
  For i% = 1 To Ini.Count   'Parcourir toutes les sections
    Text1.Print "***" & Ini.Item(i%).Item(1) & "***"   'Le 1er item est le titre de la section
    For j% = 2 To Ini.Item(i%).Count     'Parcourir la section
      Text1.Print Ini.Item(i%).Item(j%).Item(1)   'Le nom du paramtre (qui est avant le signe =)
      For k% = 2 To Ini.Item(i%).Item(j%).Count   'Parcourir les valeurs du paramtre
        Text1.Print "   " & Ini.Item(i%).Item(j%).Item(k%)
      Next
      Text1.Print
    Next
  Next
  'Peupler la liste des types d'aliments
  Combo1.Clear
  For i% = 2 To Ini.Item("ALIMENTS").Count
    Combo1.AddItem Ini.Item("ALIMENTS").Item(i%).Item(1)
  Next
  Combo1.ListIndex = 0
End Sub

Private Sub Combo1_Click()
  Dim i%
  'Peupler la liste des diffrents aliments d'un type donn
  List1.Clear
  For i% = 2 To Ini.Item("ALIMENTS").Item(Combo1.List(Combo1.ListIndex)).Count
    List1.AddItem Ini.Item("ALIMENTS").Item(Combo1.List(Combo1.ListIndex)).Item(i%)
  Next
  List1.ListIndex = 0
End Sub

Private Sub BTajouter_Click()
  Dim dummy$
  dummy$ = Trim$(Text2)   'Il FAUT placer text2 dans une variable avant de l'affecter  la collection
  If Text2 <> "" Then
    Ini.Item("ALIMENTS").Item(Combo1.List(Combo1.ListIndex)).Add dummy$
    Text2 = ""
    Call Combo1_Click
  End If
End Sub

Private Sub BTsupprimer_Click()
  Ini.Item("ALIMENTS").Item(Combo1.List(Combo1.ListIndex)).Remove (List1.ListIndex + 2)
  Call Combo1_Click
  If List1.ListCount = 1 Then BTsupprimer.Enabled = False 'Empecher de supprimer le dernier
End Sub

Private Sub BTenregistrer_Click()
  Call SaveIni(Ini, App.Path & "\" & App.Title & ".ini")
  'Rafraichir l'affichage
  Set Ini = New Collection
  Call Form_Load
End Sub

Private Sub BTfermer_Click()
  Unload Me
End Sub

Sub GetIni(Ini As Collection, Fichier$)
  'V 1.1
  'Paramtre : la collection qui contiendra le fichier INI, le nom du fichier
  'Action : Transfre le fichier INI dans une arborescence de collections
  '
  'Le fichier INI contient des sections notes [NomDeLaSection]
  'Les sections contiennent des lignes du style paramtre=valeur(s), donc le nom du paramtre (unique dans la section) ne peux pas contenir le signe gal.
  'Les valeurs sont spares par des TAB et ne peuvent donc pas en contenir
  'Les lignes vides ou commenant par ; sont des lignes de commentaires.
  'Structure : Collection principale (Ini) : Membres : autant de collections que de section
  '                                          Cl des membres : le nom de la section
  '              Collection reprsentant une section : Membres : - En index 1, une chaine contenant le nom de la section
  '                                                              - autant de collections que de lignes dans la section
  '                                                    Cl des membres d'index > 1 : nom du paramtre
  '                Collection reprsentant un paramtre : Membres : - En index 1, une chaine contenant le nom du paramtre
  '                                                                 - Autant de chaines que de valeurs pour ce paramtre
  '                                                       Pas de cl.
  'On accdera  une valeur par : INI.item("Section").item("paramtre").item(2)   2 pour la 1re valeur, 3 pour la 2me valeur ...
  '                               Le nom de la cl en elle mme est dans INI.item("Section").item("cl").item(1)
  '                               Le nom de la section en elle-mme est dans INI.item("Section").item(1)
  Dim Tampon$, Section$, Parametre$, Compteur%, Valeurs
  Open Fichier$ For Input As #1
  While Not EOF(1)
    Line Input #1, Tampon$
    If Left$(Tampon$, 1) <> ";" And Tampon$ <> "" Then
      If Left$(Tampon$, 1) = "[" Then
        Tampon$ = Mid$(Tampon$, 2, Len(Tampon$) - 2) 'Retirer les crochets
        GoSub FinSection
        Section$ = Tampon$
        Dim MySection As New Collection
        MySection.Add Section$  'Le 1er membre contient le nom de la section
      ElseIf Section$ <> "" Then
        Parametre$ = ""
        Compteur% = InStr(Tampon$, "=")
        If Compteur% > 0 And Compteur% < Len(Tampon$) Then
          Parametre$ = Left$(Tampon$, Compteur% - 1)
          Valeurs = Split(Mid$(Tampon$, Compteur% + 1), vbTab)  'Mettre la (ou les) valeurs dans un tableau
          Dim MyCol As New Collection
          MyCol.Add Parametre$ 'Le 1er membre contient le nom du paramtre
          For Compteur% = 0 To UBound(Valeurs)
            MyCol.Add Valeurs(Compteur%)
          Next
          MySection.Add MyCol, Parametre$ 'Le nom du paramtre sert aussi de cl
          Set MyCol = Nothing
        End If
      End If
    End If
  Wend
  GoSub FinSection
  Close #1
  Exit Sub
FinSection:
  'Enregistrer la collection de la section
  If Section$ <> "" Then
    Ini.Add MySection, Section$ 'Le nom de la section sert aussi de cl
    Section$ = ""
    Set MySection = Nothing
  End If
Return
End Sub

Sub SaveIni(Ini As Collection, Fichier$)
  'V 1.0
  'Paramtre : la collection qui contient le fichier INI, le nom du fichier
  'Action : Transfre l'arborescence de collections dans le fichier
  Dim Section, i%, j%
  Open Fichier$ For Output As #1
  For Each Section In Ini
    Print #1, "[" & Section.Item(1) & "]" 'Nom de section
    For i% = 2 To Section.Count
      Print #1, Section(i%).Item(1) & "=";
      For j% = 2 To Section(i%).Count
        If j% > 2 Then Print #1, vbTab;
        Print #1, Section(i%).Item(j%);
      Next
      Print #1,
    Next
    Print #1,
  Next
  Close #1
End Sub
